defmodule Dp.Gen do

  @moduledoc """
  FP, első rész

  @author "hanak@emt.bme.hu"
  @date   "$LastChangedDate: 2022-09-19 14:59:10 +0200 (h, 19 szept 2022) $$"
  """

  @spec sum_of_squares(a::number, b::number) :: s::number
  def sum_of_squares(a,b), do: sqr(a) + sqr(b)
  defp sqr(a), do: a*a # p[rivate], i.e. local in this module

  def sum_of_sqrs_b5(a, b \\ 5), do: sqr(a) + sqr(b)

  def sum_of_sqrs_a6b5(a \\ 6, b \\ 5), do: sqr(a) + sqr(b)

  def head([]),      do: {:error, nil}
  def head([x|_xs]), do: {:ok, x}
  
  _tail = fn [] -> {:error, nil}; [_x|xs] -> {:ok, xs} end
  # cnt_a = fn [] -> 0; [_x|xs] -> (cnt_a xs) + 1 end

  def cnt_n([]), do: 0; def cnt_n([_x|xs]), do: (cnt_n xs) + 1

  def hello_1(msg, name), do: (IO.write msg; IO.puts ", mizújs, #{name}?")

  def hello_2(msg, name), do: (  # csoportosítás zárójelezéssel
    IO.write msg                 # pontosvessző helyett új sorba
    IO.puts ", mizújs, #{name}?"
  )

  def hello_3(msg, name) do      # zárójel helyett do...end
    IO.write msg
    IO.puts ", mizújs, #{name}?"
  end

  def fac(0), do: 1            # ha az n=0 mintaillesztés sikeres
  def fac(n), do: n * fac(n-1) # ha az n=0 mintaillesztés sikertelen

  def fac_1(0),            do: 1            # ha az n=0 mintaillesztés sikeres
  def fac_1(n) when n > 0, do: n * fac_1(n-1) # ha az n=0 mintaillesztés sikertelen

  def fac_2(0),                             do: 1              # ha az n=0 mintaillesztés sikeres
  def fac_2(n) when is_integer(n) and n > 0, do: n * fac_2(n-1) # ha az n=0 mintaillesztés sikertelen

  def filter(_pred, []), do: []
  def filter(pred, [x|xs]) do
    cond do
      pred.(x) ->
	[x | filter(pred, xs)]
      true
	-> filter(pred, xs)
    end
  end

  @spec pitag(n::integer) :: ps::[{integer,integer,integer}]
  def pitag(n), do:
    (ls = 1..n
     for a <- ls, b <- ls, a <= b,
         c <- ls, a + b + c <= n,
         a * a + b * b === c * c,
           do: {a, b, c}
    )

  @spec freq(val::any, ls::[any]) :: n::integer
  #  ls-ben a val értékű elemek száma n
  def freq(val, ls), do:
    length(for x <- ls, b = (x === val), do: b)

  def qsort([]), do: []
  def qsort([pivot|tail]), do:
    qsort(for x <- tail, x < pivot, do: x) ++
      [ pivot | qsort(for x <- tail, x >= pivot, do: x) ]

  @spec perms(xs::[any]) :: pss::[[any]]
  # Az xs lista elemeinek összes permutációját tartalmazó lista pss
  def perms([]), do: [[]]
  def perms(xs), do: for y <- xs, ys <- perms(xs--[y]), do: [y|ys]
    
end
